

int branchingAngle = 35;
float branchLength = 4.0;
String startString = "F";
String plantStructure;
HashMap<Character, String> productionRules;

String evolveStructure(String currentStructure) {
  String newStructure = "";
  for (int i = 0; i < currentStructure.length(); i++) {
    char currentChar = currentStructure.charAt(i);
    String replacementRule = productionRules.get(currentChar);
    if (replacementRule != null) {
      newStructure += replacementRule;
    } else {
      newStructure += currentChar;
    }
  }
  return newStructure;
}


void setup() {
  size(700, 650); 
  background(255);
  stroke(0);
  strokeWeight(1);
  
  productionRules = new HashMap<Character, String>();
  productionRules.put('F', "FF-[-F+F+F]+[+F-F-F]");
  
  plantStructure = startString;
  for (int i = 0; i < 5; i++) {
    plantStructure = evolveStructure(plantStructure);
  }
  
  translate(width/2, height);
  for (int i = 0; i < plantStructure.length(); i++) {
    char currentChar = plantStructure.charAt(i);
    if (currentChar == 'F') {
      line(0, 0, 0, -branchLength);
      translate(0, -branchLength);
    } else if (currentChar == '+') {
      rotate(radians(branchingAngle));
    } else if (currentChar == '-') {
      rotate(-radians(branchingAngle));
    } else if (currentChar == '[') {
      pushMatrix();
    } else if (currentChar == ']') {
      popMatrix();
    }
  }
}
