
int rotateAngle = 22;

float segmentLength = 2.0;

String initialString = "F";

String plantStructure;

HashMap<Character, String> generationRules;

String evolveStructure(String currentStructure) {
  String newStructure = "";
  for (int i = 0; i < currentStructure.length(); i++) {
    char currentChar = currentStructure.charAt(i);
    String replaceRule = generationRules.get(currentChar);
    if (replaceRule != null) {
      newStructure += replaceRule;
    } else {
      newStructure += currentChar;
    }
  }
  return newStructure;
}

void setup() {
  size(800, 800); 
  background(255);
  stroke(0);
  strokeWeight(1);
  
  generationRules = new HashMap<Character, String>();
  generationRules.put('F', "FF[+F][-F][+F][-F]");
  
  plantStructure = initialString;
  for (int i = 0; i < 7; i++) {
    plantStructure = evolveStructure(plantStructure);
  }
  
  translate(width/2, height);
  for (int i = 0; i < plantStructure.length(); i++) {
    char currentChar = plantStructure.charAt(i);
    if (currentChar == 'F') {
      line(0, 0, 0, -segmentLength);
      translate(0, -segmentLength);
    } else if (currentChar == '+') {
      rotate(radians(rotateAngle));
    } else if (currentChar == '-') {
      rotate(-radians(rotateAngle));
    } else if (currentChar == '[') {
      pushMatrix();
    } else if (currentChar == ']') {
      popMatrix();
    }
  }
}
