
int rotationAngle = 50;

float stemLength = 2.0;

String initialString = "X";

String generatedStructure;

HashMap<Character, String> productionRules;

String evolveStructure(String currentStructure) {
  String newStructure = "";
  
  for (int i = 0; i < currentStructure.length(); i++) {
    char currentCharacter = currentStructure.charAt(i);
    
    String replacementRule = productionRules.get(currentCharacter);
    
    if (replacementRule != null) {
      newStructure += replacementRule;
    } else {
      newStructure += currentCharacter;
    }
  }
  return newStructure;
}

void setup() {
  
  size(500, 500); 
  
  background(255);
  
  stroke(0);
  
  strokeWeight(2);
  
  productionRules = new HashMap<Character, String>();
  
  productionRules.put('F', "F[+F]F[-F]F");
  productionRules.put('X', "F-[[X]+X]+F[+FX]-X");
  
  generatedStructure = initialString;
  
  for (int i = 0; i < 4; i++) {
    generatedStructure = evolveStructure(generatedStructure);
  }
  
  translate(width/2, height);
  
  for (int i = 0; i < generatedStructure.length(); i++) {
    char currentCharacter = generatedStructure.charAt(i);
    
    if (currentCharacter == 'F') {
      line(0, 0, 0, -stemLength);
      translate(0, -stemLength);
    } else if (currentCharacter == '+') {
      rotate(radians(rotationAngle));
    } else if (currentCharacter == '-') {
      rotate(-radians(rotationAngle));
    } else if (currentCharacter == '[') {
      pushMatrix();
    } else if (currentCharacter == ']') {
      popMatrix();
    }
  }
}
